Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Oracle Configuration Interface Object API Specification Version: 11.5.10.23.13 Part No: B14186-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.apps.cz.cio
Class BomNode

    java.lang.Object
      |
      +--oracle.apps.cz.cio.RuntimeNode
            |
            +--oracle.apps.cz.cio.PricedNode
                  |
                  +--oracle.apps.cz.cio.StateNode
                        |
                        +--oracle.apps.cz.cio.StateCountNode
                              |
                              +--oracle.apps.cz.cio.OptionFeatureNode
                                    |
                                    +--oracle.apps.cz.cio.BomNode

All Implemented Interfaces:
  IAtp, IBasicPrice, IBomItem, ICount, IOption, IOptionFeature, IPrice, IRuntimeNode, IState

Direct Known Subclasses:
  BomInstance, BomOptionClass, BomStdItem

public abstract class BomNode
extends OptionFeatureNode
implements IBomItem

Represents configurable BOM option classes.

Field Summary
`static java.lang.String` | `RCS_ID`
`static boolean` | `RCS_ID_RECORDED`

Fields inherited from class oracle.apps.cz.cio.RuntimeNode
`ACCUMULATOR_SUFFIX_TYPE, ATTR_KEY, CONNECTOR_PREFIX_TYPE, DEFAULT_IV_SUFFIX_TYPE, DEFAULT_SUFFIX_ID, DEFAULT_SUFFIX_TYPE, LOAD_CONDITIONS_GROUP_PREFIX_TYPE, NET_PREFIX_TYPE, NODE_PREFIX_TYPE, TRACKABLE_ROOT_PREFIX_TYPE`

Fields inherited from interface oracle.apps.cz.cio.IState
`FALSE, LFALSE, LTRUE, SELECTABLE, SYSTEM_EXCLUDED, TOGGLE, TRUE, UFALSE, UNKNOWN, UTRUE`

Fields inherited from interface oracle.apps.cz.cio.IRuntimeNode
`ALL_FEATURES, BOM_MODEL, BOM_OPTION_CLASS, BOM_STD_ITEM, BOOLEAN_FEATURE, COMPONENT, COMPONENT_SET, CONNECTOR, COUNT_FEATURE, CURRENT_CHILD, CURRENT_OR_DISCONTINUED_CHILD, DECIMAL_FEATURE, DISCONTINUED_CHILD, EDITABLE, EXTENDED_PASSIVE, IMMEDIATE_PASSIVE, INTEGER_FEATURE, OPTION, OPTION_FEATURE, RESOURCE, SPOOFED, TEXT_FEATURE, TOTAL`

Method Summary
`void` | `addAtpNotification(java.lang.String message)`
`boolean` | `areOptionsCounted()` Returns `true` if the Feature has counted options.
`void` | `clearAtpDate()`
`void` | `clearAtpNotifications()`
`void` | `deselect()` Deselect this option.
`java.util.Date` | `getAtpDate()` This method is used to price the item when price_list_id is provided, through the CZ provided pricing package.
`java.lang.String` | `getAtpNotifications()` Returns string containing any ATP messages, warnings or errors generated for this node by the latest Configuration.calculateAtpDates call.
`java.lang.String` | `getComponentCode()` Returns component code of item.
`double` | `getDecimalDefaultQuantity()` Gets the decimal default quantity.
`double` | `getDecimalMaxQuantity()` Gets the maximum quantity.
`double` | `getDecimalMinQuantity()` Gets the minimum quantity.
`int` | `getDefaultQuantity()` Gets the integer default quantity.
`java.lang.String` | `getECC()` Returns the Extended Component Code (ECC) of this BOM item.
`java.lang.String` | `getFormattedAtpDate()` Retrieves last ATP date calculated and formatted by Configuration.calculateAtpDatesMls for this item.
`int` | `getInventoryItemId()` Returns Oracle Applications inventory_item_id of item.
`java.lang.String` | `getItemKey()` Returns item key for items imported from Oracle Inventory / BOM.
`int` | `getMaxQuantity()` Gets the maximum quantity.
`int` | `getMinQuantity()` Gets the minimum quantity.
`int` | `getOrganizationId()` Returns Oracle Applications organization_id of item.
`java.lang.String` | `getPrimaryUomCode()` Gets primary unit of measure code for item.
`int` | `getState()` Gets the current logic state of this object.
`java.lang.String` | `getUomCode()` Returns unit of measure code for items imported from Oracle Inventory/ BOM.
`boolean` | `hasDefaultQuantity()` Reuturns true if the BOM item has default quantity
`boolean` | `hasMaxQuantity()` Reuturns true if the BOM item has maximum quantity
`boolean` | `hasMinQuantity()` Returns true if the BOM item has minimum quantity
`boolean` | `isOptionCounted()` Returns true if this is a counted option on which a count can be set
`boolean` | `isOptionMutexed()` Returns true if this option is a child of a mutexed parent
`boolean` | `isRequired()` Returns `true` if this is a required BOM item.
`boolean` | `isSelected()` Returns `true` if this option is selected, and `false` otherwise.
`boolean` | `isSelectionMutexed()` Returns `true` if this feature supports mutexed selections.
`void` | `select()` Select this option.
`void` | `select(oracle.apps.cz.cio.IOption option)` Select a particular option.
`void` | `setAtpDate(java.util.Date atpDate)`
`void` | `setState(int newState)` Change the current logic state of this object.
`void` | `toggleAndSetCount(int newCount)` Set the count of the option.
`void` | `toggleAndSetDecimalCount(double newCount)`

Methods inherited from class oracle.apps.cz.cio.OptionFeatureNode
`deselect, getAvailableOptions, getMaxSelected, getMinSelected, getSelectableChildren, getSelectedOption, getSelectedOptions, hasMaxSelected, hasMinSelected`

Methods inherited from class oracle.apps.cz.cio.StateCountNode
`getCount, getDecimalCount, setCount, setDecimalCount, toString`

Methods inherited from class oracle.apps.cz.cio.StateNode
`getDetailedSelectionState, getSelectionState, isFalse, isFalseState, isLogic, isLogicState, isTrue, isTrueState, isUnknown, isUnknownState, isUser, isUserState, statesMatch, unset`

Methods inherited from class oracle.apps.cz.cio.PricedNode
`addDiscountedPricingNotification, addListPricingNotification, cacheCurrentDiscountedPrice, clearDiscountedPrice, clearDiscountedPricingNotifications, clearListPricingNotifications, getBaselineQuantity, getDeltaQuantity, getDiscountedPrice, getDiscountedPricingNotifications, getExtendedPrice, getListPrice, getListPricingNotifications, getOldDiscountedPrice, getPricedNodeID, getPricingNotifications, getPricingValue, getValue, hasDiscountedPrice, hasInventoryItemId, hasListPrice, setDiscountedPrice, setListPrice`

Methods inherited from class oracle.apps.cz.cio.RuntimeNode
`associateAttribute, evaluateUiExpression, getAttributeByName, getAttributes, getAvailableEventCommands, getBaselineValue, getCaption, getChildByID, getChildByID, getChildByName, getChildByName, getChildByPersistentID, getChildByPersistentID, getChildren, getChildrenByType, getConfigItemID, getConfiguration, getCurrentValue, getCXRules, getDatabaseID, getDeltaValue, getDescription, getDiscontinuedChildren, getDisplayName, getDisplayNamePath, getFuncCompByID, getFuncCompByName, getFunctionalCompanions, getInstalledValue, getLineType, getLineTypeName, getLoadStatus, getLocationID, getLocationTypeCode, getName, getParent, getPersistentID, getProperties, getPropertyById, getPropertyByName, getRootInstance, getRuntimeID, getSelectionLineID, getSummaryChildren, getSummaryValue, getType, hasAttribute, hasChildren, hasChildren, hasConfigItemID, hasCount, hasDecimalValue, hasDescription, hashCode, hasIntegerValue, hasSelectionLineID, hasState, hasTextValue, hasTrackableAncestor, isAddChanged, isAttributeChanged, isChanged, isChildChanged, isDefaultAffected, isDeleteChanged, isDeleted, isDiscontinued, isEditable, isEffective, isIBNodeChanged, isIBNodeOrDescendantChanged, isIBTrackable, isLoaded, isLocationChanged, isNameChanged, isNative, isNodeChanged, isQuoteable, isRoot, isRootInstance, isSatisfied, isTargetChanged, isTrackableRoot, isUiVisible, isUnsatisfied, isUnsatisfiedNode, isValid, isValueChanged, lookupNodeID, lookupNodeID, registerLoadCondition, setLineType, setLocationID, setLocationTypeCode, synchronizeIBValues, typeToString`

Methods inherited from class java.lang.Object
`equals, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface oracle.apps.cz.cio.IOptionFeature
`deselect, getMaxSelected, getMinSelected, getSelectableChildren, getSelectedOption, getSelectedOptions, hasMaxSelected, hasMinSelected`

Methods inherited from interface oracle.apps.cz.cio.IState
`getDetailedSelectionState, getSelectionState, isFalse, isLogic, isTrue, isUnknown, isUser, unset`

Methods inherited from interface oracle.apps.cz.cio.IRuntimeNode
`evaluateUiExpression, getAvailableEventCommands, getCaption, getChildByID, getChildByName, getChildByPersistentID, getChildren, getChildrenByType, getConfigItemID, getConfiguration, getCurrentValue, getDatabaseID, getDeltaValue, getDescription, getDiscontinuedChildren, getDisplayName, getDisplayNamePath, getInstalledValue, getLineType, getLineTypeName, getLoadStatus, getLocationID, getLocationTypeCode, getName, getParent, getPersistentID, getProperties, getPropertyByName, getRootInstance, getRuntimeID, getSelectionLineID, getSummaryChildren, getSummaryValue, getType, hasChildren, hasConfigItemID, hasCount, hasDecimalValue, hasDescription, hasIntegerValue, hasSelectionLineID, hasState, hasTextValue, hasTrackableAncestor, isAddChanged, isAttributeChanged, isChanged, isChildChanged, isDeleteChanged, isDeleted, isDescendantOf, isDiscontinued, isEditable, isEffective, isIBNodeChanged, isIBNodeOrDescendantChanged, isIBTrackable, isLoaded, isLocationChanged, isNameChanged, isNative, isNodeChanged, isQuoteable, isRoot, isRootInstance, isSatisfied, isTargetChanged, isTrackableRoot, isUiVisible, isUnsatisfied, isUnsatisfiedNode, isValid, isValueChanged, setLineType, setLocationID, setLocationTypeCode`

Methods inherited from interface oracle.apps.cz.cio.ICount
`getCount, getDecimalCount, setCount, setDecimalCount`

Methods inherited from interface oracle.apps.cz.cio.IPrice
`getBaselineQuantity, getDeltaQuantity, getDiscountedPrice, getDiscountedPricingNotifications, getExtendedPrice, getPricingNotifications`

Methods inherited from interface oracle.apps.cz.cio.IBasicPrice
`addListPricingNotification, getListPrice, getListPricingNotifications, getPricedNodeID, getValue, hasInventoryItemId, hasListPrice, setListPrice`

Methods inherited from interface oracle.apps.cz.cio.IAtp
`getDatabaseID, hasAtpDate`

Field Detail

### RCS_ID

    public static final java.lang.String RCS_ID

### RCS_ID_RECORDED

    public static final boolean RCS_ID_RECORDED

Method Detail

### getState

    public int getState()

  Description copied from interface: `IState`
  Gets the current logic state of this object.
  Specified by:
    `getState` in interface `IState`
  Overrides:
    `getState` in class `StateNode`
  Returns:
    the current state.

### setState

    public void setState(int newState)
                  throws LogicalException

  Description copied from interface: `IState`
  Change the current logic state of this object.
  Specified by:
    `setState` in interface `IState`
  Overrides:
    `setState` in class `StateNode`
    `LogicalException`

### isSelectionMutexed

    public boolean isSelectionMutexed()

  Description copied from interface: `IOptionFeature`
  Returns `true` if this feature supports mutexed selections. When a selection is mutexed, it means that only one of a particular option is selectable at any one time, and selecting one option automatically deselects any other option that is mutexed and currently selected.
  Specified by:
    `isSelectionMutexed` in interface `IOptionFeature`
  Overrides:
    `isSelectionMutexed` in class `OptionFeatureNode`

### select

    public void select(oracle.apps.cz.cio.IOption option)
                throws LogicalException

  Description copied from interface: `IOptionFeature`
  Select a particular option.
  Specified by:
    `select` in interface `IOptionFeature`
  Overrides:
    `select` in class `OptionFeatureNode`
  Parameters:
    `option` - the option to be selected.
    `LogicalException`

### isSelected

    public boolean isSelected()

  Description copied from interface: `IOption`
  Returns `true` if this option is selected, and `false` otherwise.
  Specified by:
    `isSelected` in interface `IOption`

### select

    public void select()
                throws LogicalException

  Description copied from interface: `IOption`
  Select this option.
  Specified by:
    `select` in interface `IOption`
    `LogicalException`

### deselect

    public void deselect()
                  throws LogicalException

  Description copied from interface: `IOption`
  Deselect this option.
  Specified by:
    `deselect` in interface `IOption`
    `LogicalException`

### isOptionMutexed

    public boolean isOptionMutexed()

  Description copied from interface: `IOption`
  Returns true if this option is a child of a mutexed parent
  Specified by:
    `isOptionMutexed` in interface `IOption`

### isOptionCounted

    public boolean isOptionCounted()

  Description copied from interface: `IOption`
  Returns true if this is a counted option on which a count can be set
  Specified by:
    `isOptionCounted` in interface `IOption`

### toggleAndSetCount

    public void toggleAndSetCount(int newCount)
                           throws LogicalException

  Description copied from interface: `IOption`
  Set the count of the option. If this option's parent is mutually exclusive and already has a selection, this method will first try to deselect it
  Specified by:
    `toggleAndSetCount` in interface `IOption`
    `LogicalException`

### toggleAndSetDecimalCount

    public void toggleAndSetDecimalCount(double newCount)
                                  throws LogicalException

  Specified by:
    `toggleAndSetDecimalCount` in interface `IOption`
    `LogicalException`

### isRequired

    public boolean isRequired()

  Description copied from interface: `IBomItem`
  Returns `true` if this is a required BOM item.
  Specified by:
    `isRequired` in interface `IBomItem`

### hasMinQuantity

    public boolean hasMinQuantity()

  Description copied from interface: `IBomItem`
  Returns true if the BOM item has minimum quantity
  Specified by:
    `hasMinQuantity` in interface `IBomItem`

### getMinQuantity

    public int getMinQuantity()

  Description copied from interface: `IBomItem`
  Gets the minimum quantity.
  Specified by:
    `getMinQuantity` in interface `IBomItem`

### getDecimalMinQuantity

    public double getDecimalMinQuantity()

  Description copied from interface: `IBomItem`
  Gets the minimum quantity.
  Specified by:
    `getDecimalMinQuantity` in interface `IBomItem`

### hasMaxQuantity

    public boolean hasMaxQuantity()

  Description copied from interface: `IBomItem`
  Reuturns true if the BOM item has maximum quantity
  Specified by:
    `hasMaxQuantity` in interface `IBomItem`

### getMaxQuantity

    public int getMaxQuantity()

  Description copied from interface: `IBomItem`
  Gets the maximum quantity.
  Specified by:
    `getMaxQuantity` in interface `IBomItem`

### getDecimalMaxQuantity

    public double getDecimalMaxQuantity()

  Description copied from interface: `IBomItem`
  Gets the maximum quantity.
  Specified by:
    `getDecimalMaxQuantity` in interface `IBomItem`

### hasDefaultQuantity

    public boolean hasDefaultQuantity()

  Description copied from interface: `IBomItem`
  Reuturns true if the BOM item has default quantity
  Specified by:
    `hasDefaultQuantity` in interface `IBomItem`

### getDefaultQuantity

    public int getDefaultQuantity()

  Description copied from interface: `IBomItem`
  Gets the integer default quantity.
  Specified by:
    `getDefaultQuantity` in interface `IBomItem`

### getDecimalDefaultQuantity

    public double getDecimalDefaultQuantity()

  Description copied from interface: `IBomItem`
  Gets the decimal default quantity.
  Specified by:
    `getDecimalDefaultQuantity` in interface `IBomItem`

### getAtpDate

    public java.util.Date getAtpDate()
                              throws AtpUnavailableException,
                                     NoAtpCalculatedException

  This method is used to price the item when price_list_id is provided, through the CZ provided pricing package.
  Specified by:
    `getAtpDate` in interface `IAtp`
  Returns:
    ATP date
  Throws:
    `AtpUnavailableException` - thrown if ATP initialization parameters were not provided
    `NoAtpCalculatedException` - thrown if ATP was never demanded or if the ATP procedure did not calculate an ATP date for this node

### getFormattedAtpDate

    public java.lang.String getFormattedAtpDate()
                                         throws AtpUnavailableException,
                                                NoAtpCalculatedException

  Description copied from interface: `IAtp`
  Retrieves last ATP date calculated and formatted by Configuration.calculateAtpDatesMls for this item.
  Specified by:
    `getFormattedAtpDate` in interface `IAtp`
  Returns:
    ATP date
  Throws:
    `AtpUnavailableException` - thrown if ATP initialization parameters were not provided
    `NoAtpCalculatedException` - thrown if ATP was never demanded or if the ATP procedure did not calculate an ATP date for this node

### setAtpDate

    public void setAtpDate(java.util.Date atpDate)

### clearAtpDate

    public void clearAtpDate()

### getAtpNotifications

    public java.lang.String getAtpNotifications()

  Description copied from interface: `IAtp`
  Returns string containing any ATP messages, warnings or errors generated for this node by the latest Configuration.calculateAtpDates call.
  Specified by:
    `getAtpNotifications` in interface `IAtp`

### addAtpNotification

    public void addAtpNotification(java.lang.String message)

### clearAtpNotifications

    public void clearAtpNotifications()

### getPrimaryUomCode

    public java.lang.String getPrimaryUomCode()

  Description copied from interface: `IBomItem`
  Gets primary unit of measure code for item.
  Specified by:
    `getPrimaryUomCode` in interface `IBomItem`

### getInventoryItemId

    public int getInventoryItemId()

  Description copied from interface: `IBomItem`
  Returns Oracle Applications inventory_item_id of item.
  Specified by:
    `getInventoryItemId` in interface `IBomItem`
  Overrides:
    `getInventoryItemId` in class `PricedNode`

### getOrganizationId

    public int getOrganizationId()

  Description copied from interface: `IBomItem`
  Returns Oracle Applications organization_id of item.
  Specified by:
    `getOrganizationId` in interface `IBomItem`
  Overrides:
    `getOrganizationId` in class `PricedNode`

### getComponentCode

    public java.lang.String getComponentCode()

  Description copied from interface: `IBomItem`
  Returns component code of item. Component code is used to identify the item within an exploded bill of materials.
  Specified by:
    `getComponentCode` in interface `IBomItem`
  Overrides:
    `getComponentCode` in class `PricedNode`

### getUomCode

    public java.lang.String getUomCode()

  Description copied from interface: `IPrice`
  Returns unit of measure code for items imported from Oracle Inventory/ BOM. The unit of measure may be used by PL/SQL pricing procedures to price nodes. Returns null if node was not imported from Oracle Inventory / BOM.
  Specified by:
    `getUomCode` in interface `IPrice`
  Overrides:
    `getUomCode` in class `PricedNode`

### getItemKey

    public java.lang.String getItemKey()

  Description copied from interface: `IPrice`
  Returns item key for items imported from Oracle Inventory / BOM. Item key is constructed from BOM_EXPLOSIONS field values: "[COMPONENT_CODE]:[EXPLOSION_TYPE]:[ORGANIZATION_ID]:[TOP_ITEM_ID]" Item key may be used by PL/SQL pricing procedures to price nodes. Returns null if node was not imported from Oracle Inventory / BOM.
  Specified by:
    `getItemKey` in interface `IPrice`
  Overrides:
    `getItemKey` in class `PricedNode`

### areOptionsCounted

    public boolean areOptionsCounted()

  Description copied from interface: `IOptionFeature`
  Returns `true` if the Feature has counted options. You set counted options for a Feature in Developer, by checking the Counted Options check box.
  Specified by:
    `areOptionsCounted` in interface `IOptionFeature`

### getECC

    public java.lang.String getECC()

  Description copied from interface: `IBomItem`
  Returns the Extended Component Code (ECC) of this BOM item. Extended Component Code have instance numbers also at each level of the component code to identify the correct instance of this BOM item.
  Specified by:
    `getECC` in interface `IBomItem`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Oracle Configuration Interface Object API Specification Version: 11.5.10.23.13 Part No: B14186-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999, 2004, Oracle. All rights reserved. Oracle is a registered trademark of Oracle Corporation and/or its affiliates. Other names may be trademarks of their respective owners.